#ifndef CMAZEFIELD_H
#define CMAZEFIELD_H

#include <SDL/SDL.h>
#include <vector>

// #include "cMazeCell.h"

class cMazeCell;

class cMazeField {
public:
    SDL_Surface* render(bool showPath);

    int visit(int x, int y);
    int sWall(int x, int y, int pos, int p);
    int use(int x, int y);
    int useRow(int rowN);
    int unuse();
    int connect(int x1, int y1, int x2, int y2, bool p);
    int pickRandomN(int x, int y, bool mustVisited, int* retX, int* retY);

    bool isVisited(int x, int y);

    bool gWall(int x, int y, int pos);
    bool hasUnvisitedN(int x, int y); // has unvisited neighbours
    bool hasVisitedN(int x, int y);
    bool rowHasUnvisited(int rowN);
    int gSize();

    cMazeField(int fSize);
    ~cMazeField();

    // Dijkstra
    int sMom(int x, int y, int mX, int mY);
    int gMomX(int x, int y);
    int gMomY(int x, int y);
    int visitD(int x, int y);
    int unvisitD(int x, int y);
    bool isVisitedD(int x, int y);
    int invertD();
    int fillD();

private:
    int size; // square field
    SDL_Surface* mazeSurface;
    SDL_Surface* r;
    SDL_Surface* d;

    std::vector< std::vector<cMazeCell> > maze;
} ;

const int CELL_TOP = 1;
const int CELL_RIGHT = 2;
const int CELL_BOTTOM = 3;
const int CELL_LEFT = 4;

#endif
