#include "mtwist.h"

#include "cMaze.h"
#include "cMazeField.h"
#include "globals.h"

int cMG::generateStep() {
    if (choices.size() == 0) {
        maze->unuse();
        mazeState = MAZE_PATH;
        maze->visitD(0, 0);
    } else {
        bool stepped = false;
        bool eval = false;
        int rPick = 0;
        int px1, py1, px2, py2;

        while (!stepped) {
            if (choices.size() != 0) {
                rPick = mt_lrand() % choices.size();
                px1 = choices[rPick][0];
                py1 = choices[rPick][1];
                px2 = choices[rPick][2];
                py2 = choices[rPick][3];
                eval = evaluate(px1, py1, px2, py2); // <=
            } else {
                eval = false;
                stepped = true;
            }

            if (!eval) {
                // was geen veilige
            } else {
                // wel veilig!
                maze->connect(px1, py1, px2, py2, C_WALL);
                maze->unuse();
                maze->use(px1, py1);
                maze->use(px2, py2);

                stepped = true;

                // voeg de edges toe
                if (px1 == 0 && px2 == 0) {
                    int tx, ty;
                    int bx, by;

                    bool t, r, b;

                    tx = px1 + 1;
                    ty = py1;
                    bx = px2 + 2;
                    by = py2;

                    t = maze->gWall(px1, py1, CELL_RIGHT);
                    r = maze->gWall(tx, ty, CELL_BOTTOM);
                    b = maze->gWall(px2, py2, CELL_RIGHT);

                    if (!t) {
                        addEdge(px1, py1, px1+1, py1);
                        evaluate(px1, py1, px1+1, py1);
                    }

                    if (!r) {
                        addEdge(tx, ty, tx, ty + 1);
                        evaluate(tx, ty, tx, ty + 1);
                    }

                    if (!b) {
                        addEdge (px2, py2, px2+1, py2);
                        evaluate(tx, ty, tx, ty + 1);
                    }

                    /*
                    if (!(t || r || b)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                        // retV = true;
                    }
                    */
                } else if (px1 == mSize - 1 && px2 == mSize - 1) {
                    int tx, ty;

                    bool t, l, b;

                    tx = px1 - 1;
                    ty = py1;

                    t = maze->gWall(px1, py1, CELL_LEFT);
                    l = maze->gWall(tx, ty, CELL_BOTTOM);
                    b = maze->gWall(px2, py2, CELL_LEFT);

                    if (!t) {
                        addEdge(px1-1, py1, px1, py1);
                        evaluate(px1-1, py1, px1, py1);
                    }

                    if (!l) {
                        addEdge(tx, ty, tx, ty + 1);
                        evaluate(px1-1, py1, px1, py1);
                    }

                    if (!b) {
                        addEdge(px2 - 1, py2, px2, py2);
                        evaluate(px2 - 1, py2, px2, py2);
                    }

                    /*
                    if (!(t || l || b)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                         // retV = true;
                    }
                    */
                } else if (py1 == 0 && py2 == 0) {
                    int bx, by;

                    bool l, b, r;

                    bx = px1;
                    by = py1 + 1;

                    l = maze->gWall(px1, py1, CELL_BOTTOM);
                    b = maze->gWall(bx, by, CELL_RIGHT);
                    r = maze->gWall(px2, py2, CELL_BOTTOM);

                    if (!l) {
                        addEdge(px1, py1, px1, py1 + 1);
                    }
                    if (!b) {
                        addEdge(bx, by, bx+1, by);
                    }
                    if (!r) {
                        addEdge(px2, py2, px2, py2 + 1);
                    }

                    /*
                    if (!(l || b || r)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                        // retV = true;
                    }
                    */
                } else if (py1 == mSize - 1 && py2 == mSize - 1) {
                    int tx, ty;

                    bool l, t, r;

                    tx = px1;
                    ty = py1 - 1;

                    l = maze->gWall(px1, py1, CELL_TOP);
                    t = maze->gWall(tx, ty, CELL_RIGHT);
                    r = maze->gWall(px2, py2, CELL_TOP);

                    if (!l) {
                        addEdge(px1, py1 - 1, px1, py1);
                    }

                    if (!t) {
                        addEdge(tx, ty, tx + 1, ty);
                    }

                    if (!r) {
                        addEdge(px2, py2 - 1, px2, py2);
                    }

                    /*
                    if (!(l || t || r)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                        // retV = true;
                    }
                    */
                } else if (px1 == px2) {
                    int lx, ly;
                    int rx, ry;

                    bool tl, tr;
                    bool l, r;
                    bool bl, br;

                    lx = px1 - 1;
                    ly = py1;
                    rx = px1 + 1;
                    ry = py1;

                    tl = maze->gWall(px1, py1, CELL_LEFT);
                    tr = maze->gWall(px1, py1, CELL_RIGHT);
                    l = maze->gWall(lx, ly, CELL_BOTTOM);
                    r = maze->gWall(rx, ry, CELL_BOTTOM);
                    bl = maze->gWall(px2, py2, CELL_LEFT);
                    br = maze->gWall(px2, py2, CELL_RIGHT);

                    if (!tl) {
                        addEdge(px1 - 1, py1, px1, py1);
                    }
                    if (!tr) {
                        addEdge(px1, py1, px1 + 1, py1);
                    }
                    if (!l) {
                        addEdge(lx, ly, lx, ly + 1);
                    }
                    if (!r) {
                        addEdge(rx, ry, rx, ry + 1);
                    }
                    if (!bl) {
                        addEdge(px2 - 1, py2, px2, py2);
                    }
                    if (!br) {
                        addEdge(px2, py2, px2 + 1, py2);
                    }

                    /*
                    if (!(tl || l || bl) && !(tr || r || br)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                        // retV = true;
                    }
                    */
                } else if (py1 == py2) {
                    int tx, ty;
                    int bx, by;

                    bool tl, tr;
                    bool t, b;
                    bool bl, br;

                    tx = px1;
                    ty = py1 - 1;
                    bx = px1;
                    by = py1 + 1;

                    tl = maze->gWall(px1, py1, CELL_TOP);
                    bl = maze->gWall(px1, py1, CELL_BOTTOM);
                    t = maze->gWall(tx, ty, CELL_RIGHT);
                    b = maze->gWall(bx, by, CELL_RIGHT);
                    tr = maze->gWall(px2, py2, CELL_TOP);
                    br = maze->gWall(px2, py2, CELL_BOTTOM);

                    if (!tl) {addEdge(px1, py1 - 1, px1, py1);}
                    if (!bl) {addEdge(px1, py2, px1, py1 + 1);}
                    if (!t) {addEdge(tx, ty, tx + 1, ty);}
                    if (!b) {addEdge(bx, by, bx + 1, by);}
                    if (!tr) {addEdge(px2, py2 - 1, px2, py2);}
                    if (!br) {addEdge(px2, py2, px2, py2 + 1);}

                    /*
                    if (!(tl || t || tr) && !(bl || b || br)) {
                        addEdge(px1, py1, px2, py2);
                    } else {
                        // retV = true;
                    }
                    */
                }

                evaluate(px1, py1, px2, py2);
                // std::cout << choices.size() << "\n";
            }
        }
    }

    return 0;
}

bool cMG::evaluateW(int x1, int y1, int x2, int y2) {
    bool retV = false;
    // bool delEdge = false;

    /*if (x1 < 0 || y1 < 0 || x2 >= maze->gSize() || y2 >= maze->gSize()) {
        retV = false;
    } else {*/
        if (x1 == 0 && x2 == 0) {
            int tx, ty;
            int bx, by;

            bool t, r, b;

            tx = x1 + 1;
            ty = y1;
            bx = x2 + 2;
            by = y2;

            t = maze->gWall(x1, y1, CELL_RIGHT);
            r = maze->gWall(tx, ty, CELL_BOTTOM);
            b = maze->gWall(x2, y2, CELL_RIGHT);

            if (t || r || b) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        } else if (x1 == mSize - 1 && x2 == mSize - 1) {
            int tx, ty;

            bool t, l, b;

            tx = x1 - 1;
            ty = y1;

            t = maze->gWall(x1, y1, CELL_LEFT);
            l = maze->gWall(tx, ty, CELL_BOTTOM);
            b = maze->gWall(x2, y2, CELL_LEFT);

            if (t || l || b) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        } else if (y1 == 0 && y2 == 0) {
            int bx, by;

            bool l, b, r;

            bx = x1;
            by = y1 + 1;

            l = maze->gWall(x1, y1, CELL_BOTTOM);
            b = maze->gWall(bx, by, CELL_RIGHT);
            r = maze->gWall(x2, y2, CELL_BOTTOM);

            if (l || b || r) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        } else if (y1 == mSize - 1 && y2 == mSize - 1) {
            int tx, ty;

            bool l, t, r;

            tx = x1;
            ty = y1 - 1;

            l = maze->gWall(x1, y1, CELL_TOP);
            t = maze->gWall(tx, ty, CELL_RIGHT);
            r = maze->gWall(x2, y2, CELL_TOP);

            if (l || t || r) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        } else if (x1 == x2) {
            int lx, ly;
            int rx, ry;

            bool tl, tr;
            bool l, r;
            bool bl, br;

            lx = x1 - 1;
            ly = y1;
            rx = x1 + 1;
            ry = y1;

            tl = maze->gWall(x1, y1, CELL_LEFT);
            tr = maze->gWall(x1, y1, CELL_RIGHT);
            l = maze->gWall(lx, ly, CELL_BOTTOM);
            r = maze->gWall(rx, ry, CELL_BOTTOM);
            bl = maze->gWall(x2, y2, CELL_LEFT);
            br = maze->gWall(x2, y2, CELL_RIGHT);
            if ((tl || l || bl) && (tr || r || br))  {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        } else if (y1 == y2) { // BIJ DE BESLISSING OF DELETEEDGE WEL OF NIET ZIT HET PROBLEEM
            int tx, ty;
            int bx, by;

            bool tl, tr;
            bool t, b;
            bool bl, br;

            tx = x1;
            ty = y1 - 1;
            bx = x1;
            by = y1 + 1;

            tl = maze->gWall(x1, y1, CELL_TOP);
            bl = maze->gWall(x1, y1, CELL_BOTTOM);
            t = maze->gWall(tx, ty, CELL_RIGHT);
            b = maze->gWall(bx, by, CELL_RIGHT);
            tr = maze->gWall(x2, y2, CELL_TOP);
            br = maze->gWall(x2, y2, CELL_BOTTOM);
            if ((tl || t || tr) && (bl || b || br)) {
                // deleteEdge(x1, y1, x2, y2);
                retV = false;
            } else { // Anders kan de edge een uiteinde zijn van een muur die als ie nog een muurtje neerzet de shit afsluit!
                retV = true; // veilig!
            }
        }

            // als het ding zelf een muur is ook false;
        if (x1 == x2 && retV) {
            if (maze->gWall(x1, y1, CELL_BOTTOM)) {
                retV = false;
            }
        } else if (y1 == y1 && retV) {
            if (maze->gWall(x1, y1, CELL_RIGHT)) {
                retV = false;
            }
        }
    // }

    return retV;
}

bool cMG::evaluate(int x1, int y1, int x2, int y2) {
    bool retV = false;
    // bool delEdge = false;

    if (x1 == 0 && x2 == 0) {
        int tx, ty;
        int bx, by;

        bool t, r, b;

        tx = x1 + 1;
        ty = y1;
        bx = x2 + 2;
        by = y2;

        t = maze->gWall(x1, y1, CELL_RIGHT);
        r = maze->gWall(tx, ty, CELL_BOTTOM);
        b = maze->gWall(x2, y2, CELL_RIGHT);

        if (t || r || b) {
            deleteEdge(x1, y1, x2, y2);
        } else {
            t = evaluate(x1, y1, x1 + 1, y1);
            r = evaluate(tx, ty, tx, ty + 1);
            b = evaluate(x2, y2, x2 + 1, y2);

            if (!t && !r && !b) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        }
    } else if (x1 == mSize - 1 && x2 == mSize - 1) {
        int tx, ty;

        bool t, l, b;

        tx = x1 - 1;
        ty = y1;

        t = maze->gWall(x1, y1, CELL_LEFT);
        l = maze->gWall(tx, ty, CELL_BOTTOM);
        b = maze->gWall(x2, y2, CELL_LEFT);

        if (t || l || b) {
            deleteEdge(x1, y1, x2, y2);
        } else {
            t = evaluateW(x1 - 1, y1, x1, y1);
            l = evaluateW(tx, ty, tx, ty + 1);
            b = evaluateW(x2 - 1, y2, x2, y2);

            if (!t && !l && !b) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        }
    } else if (y1 == 0 && y2 == 0) {
        int bx, by;

        bool l, b, r;

        bx = x1;
        by = y1 + 1;

        l = maze->gWall(x1, y1, CELL_BOTTOM);
        b = maze->gWall(bx, by, CELL_RIGHT);
        r = maze->gWall(x2, y2, CELL_BOTTOM);

        if (l || b || r) {
            deleteEdge(x1, y1, x2, y2);
        } else {
            l = evaluateW(x1, y1, x1, y1 + 1);
            b = evaluateW(bx, by, x1 + 1, y1);
            r = evaluateW(x2, y2, x2, y2 + 1);

            if (!l && !b && !r) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        }
    } else if (y1 == mSize - 1 && y2 == mSize - 1) {
        int tx, ty;

        bool l, t, r;

        tx = x1;
        ty = y1 - 1;

        l = maze->gWall(x1, y1, CELL_TOP);
        t = maze->gWall(tx, ty, CELL_RIGHT);
        r = maze->gWall(x2, y2, CELL_TOP);

        if (l || t || r) {
            deleteEdge(x1, y1, x2, y2);
        } else {
            l = evaluateW(x1, y1 - 1, x1, y1);
            t = evaluateW(tx, ty, tx + 1, ty);
            r = evaluateW(x2, y2 - 1, x2, y2);

            if (!l && !t && !r) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        }
    } else if (x1 == x2) {
        int lx, ly;
        int rx, ry;

        bool tl, tr;
        bool l, r;
        bool bl, br;

        lx = x1 - 1;
        ly = y1;
        rx = x1 + 1;
        ry = y1;

        tl = maze->gWall(x1, y1, CELL_LEFT);
        tr = maze->gWall(x1, y1, CELL_RIGHT);
        l = maze->gWall(lx, ly, CELL_BOTTOM);
        r = maze->gWall(rx, ry, CELL_BOTTOM);
        bl = maze->gWall(x2, y2, CELL_LEFT);
        br = maze->gWall(x2, y2, CELL_RIGHT);
        if ((tl || l || bl) && (tr || r || br))  {
            deleteEdge(x1, y1, x2, y2);
        } else {
            tl = evaluateW(x1 - 1, y1, x1, y1);
            tr = evaluateW(x1, y1, x1 + 1, y1);
            l = evaluateW(lx, ly, lx, ly + 1);
            r = evaluateW(rx, ry, rx, ry + 1);
            bl = evaluateW(x2 - 1, y2, x2, y2);
            br = evaluateW(x2, y2, x2 + 1, y2);

            if ((!tl && !l && !bl) && (!tr && !r && !br)) {
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true;
            }
        }
    } else if (y1 == y2) { // BIJ DOOD EIND 3 OPEN 1 OPEN of 3 OPEN GEEN OPEN ZIT HET PROBLEEM
        int tx, ty;
        int bx, by;

        bool tl, tr;
        bool t, b;
        bool bl, br;

        tx = x1;
        ty = y1 - 1;
        bx = x1;
        by = y1 + 1;

        tl = maze->gWall(x1, y1, CELL_TOP);
        bl = maze->gWall(x1, y1, CELL_BOTTOM);
        t = maze->gWall(tx, ty, CELL_RIGHT);
        b = maze->gWall(bx, by, CELL_RIGHT);
        tr = maze->gWall(x2, y2, CELL_TOP);
        br = maze->gWall(x2, y2, CELL_BOTTOM);
        if ((tl || t || tr) && (bl || b || br)) {
            deleteEdge(x1, y1, x2, y2);
        } else { // Anders kan de edge een uiteinde zijn van een muur die als ie nog een muurtje neerzet de shit afsluit!
            tl = evaluateW(x1, y1 - 1, x1, y1);
            bl = evaluateW(x1, y1, x1, y1 + 1);
            t = evaluateW(tx, ty, tx + 1, ty);
            b = evaluateW(bx, by, bx + 1, by);
            tr = evaluateW(x2, y2 - 1, x2, y2);
            br = evaluateW(x2, y2, x2, y2 + 1); // Je kan een dood einde niet onderscheiden van een levend einde

            if ((!tl && !t && !tr) && (!bl && !b && !br)) { // ding heeft 1 open 1 dicht
                deleteEdge(x1, y1, x2, y2);
            } else {
                retV = true; // veilig!
            }
        }
    }



    return retV;
}

int cMG::deleteEdge(int x1, int y1, int x2, int y2) {
    bool x1i = false, y1i = false, x2i = false, y2i = false;

    for (int i = 0; i < choices.size(); i++) {
        x1i = false; y1i = false; x2i = false; y2i = false; // size_t?
        if (x1 == choices[i][0]) {x1i = true;}
        if (y1 == choices[i][1]) {y1i = true;}
        if (x2 == choices[i][2]) {x2i = true;}
        if (y2 == choices[i][3]) {y2i = true;}
        // if ((x1i && y1i) && (x2i && y2i)) {
        if ((x1 == choices[i][0] && y1 == choices[i][1]) && (x2 == choices[i][2] && y2 == choices[i][3])) {
            choices.erase(choices.begin() + i);
            break;
        }
    }

    return 0;
}

int cMG::addEdge(int x1, int y1, int x2, int y2) {
    std::vector<int> d;
    bool x1i = false, y1i = false, x2i = false, y2i = false;

    for (size_t i = 0; i < choices.size(); i++) {
        x1i = false; y1i = false; x2i = false; y2i = false;
        if (x1 == choices[i][0]) {x1i = true;}
        if (y1 == choices[i][1]) {y1i = true;}
        if (x2 == choices[i][2]) {x2i = true;}
        if (y2 == choices[i][3]) {y2i = true;}
        if (x1i && y1i && x2i && y2i) {break;}
    }

    if ((x1i && y1i && x2i && y2i)) {
        return 1;
    } else {
        d.push_back(x1);
        d.push_back(y1);
        d.push_back(x2);
        d.push_back(y2);
        choices.push_back(d);
    }

    d.clear();

    evaluate(x1, y1, x2, y2);

    return 0;
}

cMG::cMG(int size) {
    mazeState = MAZE_MGNR;
    pathState = PATH_FIND;
    lastFrame = 0;
    mSize = size;

    maze = new cMazeField(size);
    dAddFront(0, 0);
    surfEnlarged = SDL_CreateRGBSurface(SDL_SWSURFACE, 500, 500, screen->format->BitsPerPixel, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);

    for (int x = 0; x < size; x++) {
        for (int y = 0; y < size; y++) {
            maze->sWall(x, y, CELL_TOP, C_NOWALL);
            maze->sWall(x, y, CELL_LEFT, C_NOWALL);
            maze->visit(x, y);
        }
    }

    std::vector<int> tV;
    for (int x = 0; x < size - 1; x++) {
        tV.clear();
        tV.push_back(x);
        tV.push_back(0);
        tV.push_back(x+1);
        tV.push_back(0);
        choices.push_back(tV);
        // maze->sWall(x, 0, CELL_RIGHT, C_WALL);

        tV.clear();
        tV.push_back(x);
        tV.push_back(size-1);
        tV.push_back(x+1);
        tV.push_back(size-1);
        choices.push_back(tV);
        // maze->sWall(x, size-1, CELL_RIGHT, C_WALL);
    }
    for (int y = 0; y < size - 1; y++) {
        tV.clear();
        tV.push_back(0);
        tV.push_back(y);
        tV.push_back(0);
        tV.push_back(y+1);
        choices.push_back(tV);
        // maze->sWall(0, y, CELL_BOTTOM, C_WALL);

        tV.clear();
        tV.push_back(size-1);
        tV.push_back(y);
        tV.push_back(size-1);
        tV.push_back(y+1);
        choices.push_back(tV);
        // maze->sWall(size-1, y, CELL_BOTTOM, C_WALL);
    }
}

cMG::~cMG() {
    delete maze;

    SDL_FreeSurface(surfEnlarged);

    for (int x = 0; x < dFronts.size(); x++) {
        dFronts[x].clear();
    }
    dFronts.clear();

    if (choices.size() > 0) {
        for (int i = 0; i < choices.size(); i++) {
            choices[i].clear();
        }
        choices.clear();
    }
}
