#include <SDL/SDL.h>
#include <vector>

#ifndef CHECKBOXES_H
#define CHECKBOXES_H

class cCheckbox {
private:
    SDL_Rect outer;
    SDL_Rect middle;
    SDL_Rect inner;

    bool state;

    Uint8 prevMouseState;

public:
    int logic(int mX, int mY, Uint8 mouseState);
    int render();

    int setState(bool newState);
    bool getState();

    cCheckbox(int x, int y, int width, int border, bool startState);
    ~cCheckbox();
} ;

class cCheckboxes {
private:
    std::vector<cCheckbox> checkboxes;

public:
    int logic(int mX, int mY, int mouseState);
    int render();

    int getSelected();
    int setSelected(int p); // for tempo

    cCheckboxes(int x, int y, int step, bool horizontal, int amount, int checkWidth, int checkBorder);
    ~cCheckboxes();
} ;

const bool CHECK_ON = true;
const bool CHECK_OFF = false;
const int CHECK_NOCHANGE = 0;
const int CHECK_TURNON = 1;
const int CHECK_TURNOFF = 2;

#endif
