#include <SDL/SDL_ttf.h>

#include "functions.h"
#include "gamestates.h"
#include "globals.h"

int gsMenu::logic() {
    bGenerate->logic(mX, mY, mouseState);
    bHowTo->logic(mX, mY, mouseState);
    bAbout->logic(mX, mY, mouseState);
    bExit->logic(mX, mY, mouseState);

    if (bGenerate->getButtonState() == B_CLICK) {
        gameMan->setNextState(STATE_PARAMS);
    }
    if (bHowTo->getButtonState() == B_CLICK) {
        gameMan->setNextState(STATE_HOWTO);
    }
    if (bAbout->getButtonState() == B_CLICK) {
        gameMan->setNextState(STATE_ABOUT);
    }
    if (bExit->getButtonState() == B_CLICK) {
        gameMan->setNextState(STATE_EXIT);
    }

    int pFX = 0;
    int pFY = 0;
    int size = 50;

    if (inRange(pFX, 0, size) && inRange(pFY + 1, 0, size)) {
        // gameMan->setNextState(STATE_EXIT);
    }

    return 0;
}

int gsMenu::render() {
    SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 255, 255, 255));

    applySurface(header, screen, 15, 15);

    bGenerate->render();
    bHowTo->render();
    if (header != NULL) {
        bAbout->render();
    }
    bExit->render();

    SDL_Flip(screen);

    return 0;
}

gsMenu::gsMenu() {
    TTF_Font* fStd = fNormal;

    int y = 300; // Start position
    int dy = 64; // Delta Y

    bGenerate = new cButton("Genereer doolhof", 0, y, true, fStd, B_VISIBLE, B_STANDARD);
    bHowTo = new cButton("Algoritme uitleg", 0, y+dy, true, fStd, B_VISIBLE, B_STANDARD);
    bAbout = new cButton("Over Maze+", 0, y+dy*2, true, fStd, B_VISIBLE, B_STANDARD);
    bExit = new cButton("Sluiten", 0, y+dy*3, true, fStd, B_VISIBLE, B_STANDARD);

    header = NULL;
    header = loadImage("Media/header.png");
}

gsMenu::~gsMenu() {
    delete bGenerate;
    delete bHowTo;
    delete bAbout;
    delete bExit;

    SDL_FreeSurface(header);
}
