#include "mtwist.h"

#include "cMaze.h"
#include "cMazeField.h"
#include "globals.h"

int cBinary::generateStep() {
    if (mt_lrand() % 2) {
        if (nextX == maze->gSize() - 1) {
            maze->sWall(nextX, nextY, CELL_BOTTOM, C_NOWALL);
        } else {
            maze->sWall(nextX, nextY, CELL_RIGHT, C_NOWALL); // naar rechts
        }
    } else {
        if (nextY == maze->gSize() - 1) {
            maze->sWall(nextX, nextY, CELL_RIGHT, C_NOWALL);
        } else {
            maze->sWall(nextX, nextY, CELL_BOTTOM, C_NOWALL); // naar onder
        }

    }

    maze->visit(nextX, nextY);

    nextX++;
    if (nextX == maze->gSize()) {
        nextX = 0;
        nextY++;
    }

    if (nextY == maze->gSize()) {
        // normaal naar pathfinding modus;
        mazeState = MAZE_DONE;
    }

    maze->unuse();
    if (mazeState == MAZE_MGNR) {
        maze->use(nextX, nextY);
    }

    return 0;
}

cBinary::cBinary(int size) {
    mazeState = MAZE_MGNR;
    lastFrame = 0;

    maze = new cMazeField(size);

    nextX = 0;
    nextY = 0;
    lastFrame = 0;

    surfEnlarged = SDL_CreateRGBSurface(SDL_SWSURFACE, 500, 500, screen->format->BitsPerPixel, screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, screen->format->Amask);
}

cBinary::~cBinary() {
    for (int x = 0; x < path.size(); x++) {
        path[x].clear();
    }
    path.clear();

    delete maze;

    SDL_FreeSurface(surfEnlarged);
}
