#include <cmath>
#include <SDL/SDL.h>

#include "cMaze.h"
#include "cMazeField.h"
#include "constants.h"
#include "functions.h"
#include "globals.h"

int cMaze::pathfinding() {

    return 0;
}

int cMaze::render() {
    SDL_Surface* tSurf;
    float factor;

    tSurf = maze->render();

    switch (maze->gSize()) {
        case 5:
            factor = 10;
            break;
        case 25:
            factor = 2;
            break;
        case 50:
            applySurface(tSurf, screen, 0, 50);
            return 0;
            break;
    }

    enlarge(tSurf, surfEnlarged, factor); // <- HIER WAS IK MEE BEZIG

    applySurface(surfEnlarged, screen, 0, 50);

    return 0;
}

int cMaze::logic(int tempo) {
    int deltaT;

    /*
        switch (tempo) {
            case 1:
                deltaT = 500;
                break;
            case 2:
                deltaT = 100;
                break;
            case 3:
                deltaT = 1;
                break;
            default:
                deltaT = 100;
        */

    if (tempo > 1) {
            deltaT = pow(tempo - 9, 2) * (1000 / 49.0);
    }

    if (SDL_GetTicks() - lastFrame >= deltaT && tempo > 1) {
        switch (mazeState) {
            case MAZE_MGNR:
                this->generateStep();
                break;
            case MAZE_PATH:
                this->pathfinding();
                break;
            case MAZE_DONE:
                // nothing
                break;
        }

        lastFrame = SDL_GetTicks();
    }

    return 0;
}
