#include <SDL/SDL.h>
#include <vector>

#include "cMazeCell.h"

#ifndef CMAZE_H
#define CMAZE_H

const int MAZE_MGNR = 1;
const int MAZE_PATH = 2;
const int MAZE_DONE = 3;

class cMaze {
public:
                        // tempo
    virtual int logic(int);
    virtual int generateStep()=0;
    virtual int render();
    virtual int pathfinding();

    virtual ~cMaze(){};

protected:
    std::vector< std::vector<int> > path;
    cMazeField* maze;
    SDL_Surface* surfEnlarged;

    int lastFrame;
    int mazeState;
} ;

class cBinary : public cMaze {
public:
    int generateStep();

    cBinary(int size); // set mazestate set lastframe;
    ~cBinary(); // Clear vector & mazefield

private:
    int nextX, nextY;
} ;

class cPrims : public cMaze {
public:
    int generateStep();

    cPrims(int size); // set mazestate set lastframe; SET SIZE
    ~cPrims(); // Clear vector & mazefield

private:
    std::vector< std::vector<int> > fronts;

} ;

class cHuntKill : public cMaze {
public:
    int generateStep();

    cHuntKill(int size);
    ~cHuntKill();

private:
    int curX;
    int curY;
    int curRow;
    int curState;
} ;

const int HK_KILL = 1;
const int HK_HUNT = 2;

#endif
